
{$APPTYPE GUI}{$MODE DELPHI}

program Demo69;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL;

const
  NumParticle = 1000;
  
//type  

var 
  timer:array[1..2]of integer;
  p,p1,p2:TGenericParticle;											
  ColTab:array[0..11]of TGLRGB2 = ((r:202/255;g:251/255;b:251/255),(r:105/255;g:110/255;b:228/255), // palette
                                     (r:69/255;g:198/255;b:221/255), (r:1;g:1;b:1), 
                                     (r:46/255;g:192/255;b:218/255), (r:118/255;g:214/255;b:231/255),
									 (r:123/255;g:242/255;b:194/255),(r:87/255;g:238/255;b:177/255),
                                     (r:112/255;g:214/255;b:124/255),(r:180/255;g:233/255;b:186/255),
									 (r:160/255;g:204/255;b:252/255),(r:99/255;g:170/255;b:250/255));   
									 
  SelTypeParticle:integer = PARTICLE_BLEND2; 
  // PARTICLE_LIGHT,PARTICLE_NORMAL,PARTICLE_MESH,PARTICLE_DARK e PARTICLE_BLEND0..PARTICLE_BLEND10
   
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(9,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 9,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Cascata(var p:TGenericParticle;var pos:TGLVector;i:integer);
var 
  density:glfloat = 0.25; 
  speed:TGLVector = (x:0;y:0;z:75);
  color:integer;
begin
  color:=random(high(ColTab));

  p[i].pos.x:=p[i].pos.x+p[i].vel.x/(density*NumParticle);   
  p[i].pos.y:=p[i].pos.y+p[i].vel.y/(density*NumParticle);   
  p[i].pos.z:=p[i].pos.z+p[i].vel.z/(density*NumParticle);   
  p[i].vel.x:=p[i].vel.x+p[i].gravity.x;                 
  p[i].vel.y:=p[i].vel.y+p[i].gravity.y;                 
  p[i].vel.z:=p[i].vel.z+p[i].gravity.z;                
  p[i].life:=p[i].life-p[i].fade;           
  if(p[i].life<0)or(pos.y<-4)then                         
  begin
    p[i].life:=1;                               
    p[i].fade:=(random(100)/NumParticle)+0.003;     
    p[i].pos.x:=0;                                 
    p[i].pos.y:=0;                                 
    p[i].pos.z:=0;                                 
    p[i].vel.x:=speed.x+(random(40)-20);        
    p[i].vel.y:=speed.y+(random(60)-30);       
    p[i].vel.z:=speed.z+(random(30)-15);             
    p[i].col.r:=ColTab[color].r;                       
    p[i].col.g:=ColTab[color].g;                       
    p[i].col.b:=ColTab[color].b;                       
  end; 
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('muro01.bmp',0);
  TextureLoadID('water4.bmp',1);
  TextureLoadTGAID('CloudsParticles4.tga',0);
  TextureLoadTGAID('metal_shovelrust-01_df_.tga',1);  
  TextureLoadTGAID('rete00_1.tga',2);  
  
end;
begin 

  OpenGL_Texture();
  
  InitText(0,0,0,2);  
  
  SetGenericParticle(p,ColTab,NumParticle,0.1,glvector(0,-9.81,0)); 
  SetGenericParticle(p1,ColTab,NumParticle,0.1,glvector(0,-9.81,0)); 
  SetGenericParticle(p2,ColTab,NumParticle,0.1,glvector(0,-9.81,0));   
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  TextureOFF;
  glColor3f(0.8,0.8,0.8);
  glDisable(GL_LIGHTING);  
  PutglText(-380,240, 0.5,'num: '+IntToStr(SelTypeParticle));
  glEnable(GL_LIGHTING);   
  TextureON;
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('A')then
  begin
    timer[2]:=timer[2]+1;
    if timer[2]=3 then SelTypeParticle:=SelTypeParticle-1;
	if timer[2]>=10 then timer[2]:=0;
  end else timer[2]:=0;  
  if SelTypeParticle<PARTICLE_LIGHT then SelTypeParticle:=PARTICLE_BLEND10;  
    
  
  if SetglKey('D')then
  begin
    timer[1]:=timer[1]+1;
    if timer[1]=3 then SelTypeParticle:=SelTypeParticle+1;
	if timer[1]>=10 then timer[1]:=0;
  end else timer[1]:=0;
  if SelTypeParticle>PARTICLE_BLEND10 then SelTypeParticle:=PARTICLE_LIGHT;
 
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-2,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0);  
  
  SetglMouseMove(GL_M0,2);  
  glRotatef(45,0,-1,0);  
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 
  
  // muro
  TextureSelectID(0);
  Cubo2(0,0,-3, -40,0,-7, 20,13,1, 0.125);
  Cubo2(0,0,-3, -40,-5,-7, 20,0,5, 0.125);   
  
  // tubi
  TextureTGASelectID(1); 
  SupportoAsse(-15,10.25,0, 20, 1.2,1.7, 1);  
  SupportoAsse(-15,10.25,-2, 20, 0.7,1.5, 3);
  
  SupportoAsse(0,10.25,0, 20, 1.2,1.7, 1);  
  SupportoAsse(0,10.25,-2, 20, 0.7,1.5, 3);

  SupportoAsse(15,10.25,0, 20, 1.2,1.7, 1);  
  SupportoAsse(15,10.25,-2, 20, 0.7,1.5, 3);  
  
  // grata
  SetglSprite;  
  TextureTGASelectID(2);
  glPushMatrix;
  glTranslatef(-10,0,12);    
  Quad(-30,0,-10, 30,0,-10, -30,0,10, 30,0,10);  
  glPopMatrix;
  SetglSpriteOFF;    
  
  // acqua
  TextureSelectID(1);  
  glPushMatrix;
  glTranslatef(-10,-5,12);    
  Quad(-30,0,-10, 30,0,-10, -30,0,10, 30,0,10);  
  glPopMatrix;  
  
  // getti 
  LightingOFF;
  TextureTGASelectID(0); 
  GenGenericParticle(p,NumParticle, glvector(-15,10,0),2, SelTypeParticle,8,4,Cascata);
  GenGenericParticle(p1,NumParticle, glvector(0,10,0),2, SelTypeParticle,8,4,Cascata);
  GenGenericParticle(p2,NumParticle, glvector(15,10,0),2, SelTypeParticle,8,4,Cascata);  
  LightingON; 
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio su come usare il generatore di particelle', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
